# # SnipSnap::ActiveRecord
#
# Requires:
# * `gem 'activerecord'`
# * `gem 'sinatra-activerecord'`
#

require 'sinatra/activerecord'
require 'active_record'

module SnipSnap::ActiveRecordExtension
  def self.registered(app)
    app.register Sinatra::ActiveRecordExtension

    app.error ActiveRecord::RecordNotFound do
      halt 404
    end

    app.error ActiveRecord::RecordInvalid do
      halt 422
    end

    app.error ActiveRecord::RecordNotUnique do
      halt 409
    end
  end
end
