# # SnipSnap::DeliveryExtension
#
# Require Path: `snipsnap/extensions/delivery`
#

module SnipSnap::DeliveryExtension
  def self.registered(app)
    app.helpers Helpers
  end

  module Helpers
   def deliver(response)
      halt 404 if response.nil?

      if !response.is_a?(Hash) && response.respond_to?(:map)
        response = response.map{|item| to_api(item) }
      end

      content_type :json

      to_api(response).to_json
    end

    private

    def to_api(response)
      if response.respond_to?(:api_hash)
        response.api_hash
      else
        response
      end
    end
  end
end