require 'i18n'
require 'i18n/backend/fallbacks'

module SnipSnap::I18nExtension
  def self.registered(app)
    app.use Rack::Locale

    app.configure do
      I18n::Backend::Simple.send(:include, I18n::Backend::Fallbacks)
      I18n.load_path = Dir[File.join(app.settings.root, 'config', 'locales', '*.yml')]
      I18n.backend.load_translations
    end

    app.helpers  Helpers
  end

  module Helpers
    def t(*args)
      I18n.t(*args)
    end

    def l(*args)
      I18n.l(*args)
    end

    def find_template(views, name, engine, &block)
      I18n.fallbacks[I18n.locale].each do |locale|
        super(views, "#{name}.#{locale}", engine, &block)
      end
      super(views, name, engine, &block)
    end
  end
end
